
;Some misc macros for SPASM


;Extend SPASM directives

#macro align(boundary)
; Sets the current program counter value to the next multiple of boundary.
 .fill boundary-($%boundary)
#endmacro
#define .align align(

#macro REPEAT(code,times)
#if times==0
#include temp.asm
 .echo > temp.asm ""
#else
 .echo >> temp.asm code,"\n"
 REPEAT(code,eval(times-1))
#endif
#endmacro
#define .repeat REPEAT(
;l:
; .repeat " ld a,1",8
;m:
; .echo m-l

;File handling
#macro fopen(file)
  #include file
#endmacro

#macro fnew(file,text)
  #ifndef text
  .echo > file
  #else
  .echo > file text,"\n"
  #endif
#endmacro

#macro fwrite(file,text)
  .echo >> file text, "\n"
#endmacro

;by James Montelongo
#define fatal(str, return) #if return != 0 \ .echo "At byte ",$," of the program: ",str \ .error return \ #endif

;echo the size
#macro echosize(label,end)
 #ifdef end
  .echo eval(end-label)
 #else
  .echo eval($-label)
 #endif
#endmacro
#define .echosize echosize 

;Assemble time math
;------------------
#macro abs(n)
#if n<0
 -n
#else
 n
#endif
#endmacro

;Alternative number generator
#define r_randseed 491987
#define r_randreg $D4AD369B

#macro rand(min,max)
  #define r_ans eval(r_randseed << 8 ^ r_randseed >> 8 ^ (r_randreg >> (r_randseed % max)) & $7FFFFFFF)
  #define r_randseed eval(r_ans ^ r_randseed)
  (ans % max)
#endmacro

;Factorial (!)
#macro factorial(num)
 #if num > 1
  num*factorial(num-1)
 #else
  1
 #endif
#endmacro
; .echo factorial(5)


; OTHERS
#macro str_pad_end(str, size)

_:
 .db str
#define str_len eval($- -_)
#if str_len <= size
 .fill size-str_len,' '
 .db 0    ; NULL terminator
#else
 .error "String size is ",str_len-size," character(s) too long."
#endif
#endmacro

;C Data
;------
#define BYTE(x) .db x
#define DWORD(x) .dw x,0
#define WORD(x) .dw x
#define LONG(x) .dw x \ #if x < 0 \ .dw $FF \ #else \ .dw 0 \ #endif

;OTHERS

#macro m_var(name,num)
#define name eval(num)
#endmacro

#macro dec_var()


#endmacro

;--------
;TD-Linux
#macro m_var(name,num)
#define name num
#endmacro

#macro loop(n)
#if n > 0
#define counter eval(counter+1) ;increase 'counter' by 'size'
 loop(n-1)
#endif
#endmacro

;=END=
;=====